#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Food {
    int expiration, quality, id;
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<Food> food;

    for (int i = 0; i < n; i++) {
        int e, q;
        cin >> e >> q;
        if (q < 4) continue;
        food.push_back({e, q, i + 1});
    }

    sort(food.begin(), food.end(), [](const Food &a, const Food &b) {
        return a.expiration < b.expiration;
    });

    vector<Food> low, high;
    for (const auto &f : food) {
        if (f.quality == 4) low.push_back(f);
        else if (f.quality > 4) high.push_back(f);
    }

    int max_k = n;
    while (max_k >= 0) {
        vector<Food> lq = low, hq = high;
        vector<pair<int, int>> pairs;
        bool valid = true;

        for (int k = max_k; k > 0; --k) {
            if (hq.empty() || hq.back().expiration < k) {
                valid = false;
                break;
            }
            Food f1 = hq.back(); hq.pop_back();

            Food f2;
            if (!lq.empty() && lq.back().expiration >= k) {
                f2 = lq.back(); lq.pop_back();
            } else if (!hq.empty() && hq.back().expiration >= k) {
                f2 = hq.back(); hq.pop_back();
            } else {
                valid = false;
                break;
            }

            pairs.emplace_back(f1.id, f2.id);
        }

        if (valid) {
            cout << max_k << endl;
            for (auto it = pairs.rbegin(); it != pairs.rend(); ++it) {
                cout << it->first << " " << it->second << endl;
            }
            return 0;
        }

        max_k--;
    }

    cout << "0" << endl;
    return 0;
}
